/*********************************************************

Project : TCP/IP Messages

File    : server.p

Author  : Sascha Wolterink
          Wolterink@web.de

Date    : 30.05.2003

Desc    : Send Messages with TCP/IP

Syntax  : RUN server.p

**********************************************************/



/* VARIABLES *********************************************/
DEF VAR    hServerSocket   AS HANDLE   NO-UNDO.
DEF VAR    aOk             AS LOGICAL  NO-UNDO.
DEF VAR    mBuffer         AS MEMPTR   NO-UNDO.

/* CREATE server-socket **********************************/
CREATE SERVER-SOCKET hServerSocket.
   
hServerSocket:SET-CONNECT-PROCEDURE("connProc":U).

aOk = hServerSocket:ENABLE-CONNECTIONS( "-S 3333"). /* 3333 = free Port*/

IF NOT aOk THEN
   RETURN.

REPEAT
   ON ERROR  UNDO, LEAVE
   ON ENDKEY UNDO, LEAVE:

   WAIT-FOR CONNECT OF hServerSocket.

END.
aOk = hServerSocket:DISABLE-CONNECTIONS().
   
/* PROCEDURE connProc ************************************/
PROCEDURE connProc:
   DEF INPUT PARAM hSocket AS HANDLE.
   
   DEF VAR c_title    AS CHAR NO-UNDO INIT "".
   DEF VAR c_message  AS CHAR NO-UNDO INIT "".

   SET-SIZE(mBuffer) = 255.
   hSocket:READ(mBuffer,1,255,2).
   
   /* message from client */
   ASSIGN c_title   = ENTRY(1, GET-STRING(mBuffer,1), "|")
          c_message = ENTRY(2, GET-STRING(mBuffer,1), "|").

   MESSAGE c_message VIEW-AS ALERT-BOX TITLE c_title.
   
END PROCEDURE.
